<?php
/*********************************************************************************
	Debit API Demo - Bankdaten
	- bietet Inhalt von $offerList zur Auswahl an
	- ermittelt verfügbare Länder und zeigt sie an
*********************************************************************************/
require_once 'config.php';

$break = false;
try {
// dispatcher erzeugen
	$dispatcher = new TNvpServiceDispatcher(MCP__DEBITSERVICE_INTERFACE, MCP__DEBITSERVICE_NVP_URL);

// user ermitteln
	$username = getSessionVar('username');
	if (empty($username)) throw new Exception('Loggen Sie sich erst ein oder melden Sie sich an!');

// wenn Formular nicht gesendet wurde
	if (getPostVar('action') != 'bankaccount') {
	// bereits hinterlegte Bankdaten ermitteln
		try{
			$res = $dispatcher->bankaccountGet(SERVICE_ACCESSKEY, SERVICE_TESTMODE, $username);
			$GLOBALS['debug']['dispatcher']['bankaccountGet'][] = $res;

			$bankcode = $res['bankCode'];
			$bank = $res['bankName'];
			$holder = $res['accountHolder'];
			$account = $res['accountNumber'];
			$iban = $res['iban'];
			$bic = $res['bic'];
			$country = $res['country'];
			$barStatus = $res['barStatus'];
			$break = true;
		} catch (Exception $e){
			$GLOBALS['debug']['exception'][] = $e;
			if($e->getCode() == ERR_BANKACCOUNT_NOTSET) $break = true;
			throw $e;
		}
		throw new Exception('action != bankaccount');
	}

// Eingaben ermitteln
	$holder = getPostVar('holder');
	$account = getPostVar('account');
	$bankcode = getPostVar('bankcode');
	$iban = getPostVar('iban');
	$bic = getPostVar('bic');
// Land setzen -> evtl. durch Formular abfragen
	$country = getSessionVar('country', DEFAULT_COUNTRY);

	if(empty($iban) && empty($bic)) {
		$useIban = false;
	} else {
		$useIban = true;
	}

// Eingaben prüfen
	if (empty($holder)) throw new Exception('Geben Sie den Kontoinhaber ein');

	if($useIban){
		if(empty($iban)) throw new Exception('Geben Sie den IBAN ein');
	// optional BIC
		//if(empty($bic)) throw new Exception('Geben Sie den BIC ein');
	} else {
		if(empty($account)) throw new Exception('Geben Sie Ihre Kontonummer ein');
		if(empty($bankcode)) throw new Exception('Geben Sie Ihre Bankleitzahl ein');
	}

	try{
	// Konto setzen
		$res = $dispatcher->bankaccountSet(SERVICE_ACCESSKEY, SERVICE_TESTMODE, $username,
											$iban,
											$bic,
											$country,
											$bankcode,
											$account,
											$holder);
		$GLOBALS['debug']['dispatcher']['bankaccountSet'][] = $res;

	// erfolgreich
		include('page.offer.php');
	} catch (Exception $e){
		$GLOBALS['debug']['exception'][] = $e;
		throw new Exception(errorCode2Txt($e->getCode(), 'SYSERROR'));
	}
	return;

} catch (Exception $e) {
	$GLOBALS['debug']['exception'][] = $e;
	if(!$break) $errorText = $e->getMessage();
}
?>
<form action="index.php?page=bankaccount" method="post">
	<input type="hidden" name="action" value="bankaccount">

	<b>Geben Sie Ihre Bankdaten ein, entweder BLZ/Konto oder IBAN/BIC</b>
	<hr>

	<div>
		<label for="holder">Kontoinhaber</label><br>
		<input type="text" id="holder" name="holder" value="<?php echo $holder; ?>">
	</div>

	<div>
		<label for="account">Kontonummer</label><br>
		<input type="text" id="account" name="account" value="<?php echo $account; ?>">
	</div>

	<div>
		<label for="bankcode">Bankleitzahl</label><br>
		<input type="text" id="bankcode" name="bankcode" value="<?php echo $bankcode; ?>"> <input type="text" id="bank" name="bank" value="<?php echo $bank; ?>" readonly>
	</div>

	<div>
		<label for="iban">IBAN</label><br>
		<input type="text" id="iban" name="iban" value="<?php echo $iban; ?>">
	</div>

	<div>
		<label for="bic">BIC</label><br>
		<input type="text" id="bic" name="bic" value="<?php echo $bic; ?>">
	</div>

	<div>
		<label for="barStatus">Sperrstatus</label><br>
		<input type="text" id="barStatus" name="barStatus" value="<?php echo $barStatus; ?>" readonly>
	</div>

	<div class="center">
		<input type="submit" value="Speichern">
	</div>

	<br>
	<div class="message">
		<span class="error"><?php echo $errorText; ?></span>
		<span class="info"><?php echo $infoText; ?></span>
	</div>
</form>

