<?php
/*********************************************************************************
	Debit API Demo - Produktauswahl
*********************************************************************************/
require_once 'config.php';

$break = false;
try {
// dispatcher erzeugen
	$dispatcher = new TNvpServiceDispatcher(MCP__DEBITSERVICE_INTERFACE, MCP__DEBITSERVICE_NVP_URL);

// user ermitteln
	$username = getSessionVar('username');
	if (empty($username)) throw new Exception('Loggen Sie sich erst ein oder melden Sie sich an!');

// user abfragen
	$res = $dispatcher->customerGet(SERVICE_ACCESSKEY, SERVICE_TESTMODE, $username);
	$GLOBALS['debug']['dispatcher']['customerGet'][] = $res;

	if(!isset($res['freeParams'])) throw new Exception('User/Passwort ist ungueltige Daten');
	$freeParams = $res['freeParams'];

// daten ermitteln
	$userCoins = !empty($freeParams['coins']) ? $freeParams['coins'] : 0;
	if (!empty($freeParams['barred'])) throw new Exception('User wurde gesperrt');

// sessions abfragen
	$res = $dispatcher->sessionList(SERVICE_ACCESSKEY, SERVICE_TESTMODE, $username);
	$GLOBALS['debug']['dispatcher']['sessionList'][] = $res;

// daten ermitteln
	$sessionIdList = isset($res['sessionIdList']) ? $res['sessionIdList'] : array();
	$amount = 0;
	$sessionCoins = 0;
	if(!empty($sessionIdList)){
		foreach($sessionIdList as $sessionId) {
		// session abfragen
			$res = $dispatcher->sessionGet(SERVICE_ACCESSKEY, SERVICE_TESTMODE, $sessionId);
			$GLOBALS['debug']['dispatcher']['sessionGet'][] = $res;

		// alle ignorieren, ausser bestätigte sessions
			if ($res['status'] != 'APPROVED') continue;

		// daten summieren
			$amount += $res['amount'];
			$freeParams = $res['freeParams'];
			$sessionCoins += !empty($freeParams['coins']) ? $freeParams['coins'] : 0;
		}
	}
// nur ausführen wenn Formular unten gesendet wurde
	if (getPostVar('action') != 'offer'){
		$break = true;
		throw new Exception('action != offer');
	}

// angebot ermitteln
	$offerId = getPostVar('offerid');
	if (empty($offerId)) throw new Exception('Wählen Sie ein Angebot aus');

// angebotdaten ermitteln
	$amount = $offerList[$offerId]['amount'];
	$title = $offerList[$offerId]['title'];
	$freeParams = array(
		'coins' => $offerList[$offerId]['coins']
	);
	$ip = $_SERVER['REMOTE_ADDR'];

	$sessionid = null;
	$projectCampaign = $accountName = $webmasterCampaign = $payText = null;
	$currency = DEFAULT_CURRENCY;
	try {
		$res = $dispatcher->sessionCreate(SERVICE_ACCESSKEY, SERVICE_TESTMODE, $username,
											$sessionid,
											PROJECT_NAME,
											$projectCampaign, $accountName, $webmasterCampaign,
											$amount, $currency,
											$title, $payText,
											$ip,
											$freeParams );
		$GLOBALS['debug']['dispatcher']['sessionCreate'][] = $res;

	// erfolgreich
		setSessionVar('sessionid', $res['sessionId']);

	} catch (Exception $e) {
		$GLOBALS['debug']['exception'][] = $e;
		throw new Exception(errorCode2Txt($e->getCode(), 'SYSERROR'));
	}

	include('page.approve.php');
	return;

} catch (Exception $e) {
	$GLOBALS['debug']['exception'][] = $e;
	if(!$break) $errorText = $e->getMessage();
}
?>
<form action="index.php?page=offer" method="post">
	<input type="hidden" name="action" value="offer">

	<b>Wählen Sie Ihre Guthabenpaket</b>
	<hr>

	<div>
		Ihr aktuelles Guthaben beträgt <b><?php echo $userCoins; ?> Coins</b>.
	</div>

<?php
	if ($sessionCoins) {
?>
	<div>
		Ihnen werden weitere <b><?php echo $sessionCoins; ?> Coins</b> gutgeschrieben, sobald
		der Betrag von <b><?php echo sprintf('%0.2f EUR', $amount/100); ?></b> abgebucht wurde.
	</div>
<?php
	};
?>

<?php
// Angebote ausgeben
	foreach ($offerList as $id => $offer) {
		$amount = $offer['amount'];
		$title = $offer['title'];
?>
	<div>
		<input type="radio" id="<?php echo 'offer' . $id; ?>" name="offerid" value="<?php echo $id; ?>" <?php echo $id == $offerId ? 'checked' : ''; ?>>
		<label for="<?php echo 'offer' . $id; ?>"><?php echo $title; ?> für <?php echo sprintf('%0.2f EUR', $amount / 100); ?></label>
	</div>
<?php
	};
?>

	<hr>
	<div class="center">
		<input type="submit" value="Kaufen">
	</div>

	<br>
	<div class="message">
		<span class="error"><?php echo $errorText; ?></span>
		<span class="info"><?php echo $infoText; ?></span>
	</div>
</form>

